(function() {
  var Repository;

  Repository = (function() {

    function Repository(name, client) {
      this.name = name;
      this.client = client;
    }

    Repository.prototype._invokeGet = function(path, expectedStatus, methodName, cb) {
      if (expectedStatus == null) expectedStatus = 200;
      return this.client.get(path, function(err, s, b) {
        if (err) return cb(err);
        if (s !== expectedStatus) {
          return cb(new Error("Repository." + methodName + " error"));
        } else {
          return cb(null, b);
        }
      });
    };

    Repository.prototype.info = function(cb) {
      return this._invokeGet("/repos/" + this.name, 200, "info", cb);
    };

    Repository.prototype.getCommits = function(cb) {
      return this._invokeGet("/repos/" + this.name + "/commits", 200, "getCommits", cb);
    };

    Repository.prototype.getTags = function(cb) {
      return this._invokeGet("/repos/" + this.name + "/tags", 200, "getTags", cb);
    };

    return Repository;

  })();

  module.exports = Repository;

}).call(this);
